#include "Graf.h"

/**
* the constructor
*
* @param i the id
* @param c the cost 
*/
Nod::Nod(int i, double c)
{
	id = i;
	cost = c;
	nr_pred = 0;
	nr_succ = 0;
}

/**
* Method printing the node's information
*/
void Nod::print() 
{
	printf("[Nod id = %i cost = %lf pred{ ", id, cost);
	for(int i = 0 ; i < nr_pred ; i ++)
		printf("%i(%lf) ", ((Muchie*)predecesori[i])->predecesor->id, ((Muchie*)predecesori[i])->cost);
	printf("} succ { ");
	for(int i = 0 ; i < nr_succ ; i ++)
		printf("%i(%lf) ", ((Muchie*)succesori[i])->succesor->id, ((Muchie*)succesori[i])->cost);
	printf("}]\n");
}

/**
* Method adding a predecessor
*
* @param p the new predecessor
*/
void Nod::addPredecesor(void * p)
{
	if(nr_pred == 0 )
		predecesori = (void **)calloc(1, sizeof(void *));
	else
		predecesori = (void **)realloc(predecesori, (nr_pred+1)* sizeof(void *));
	predecesori[nr_pred] = p;
	nr_pred ++;
}

/**
* Method adding a successor
*
* @param s the new successor
*/	
void Nod::addSuccesor(void * s)
{
	if(nr_succ == 0 )
		succesori = (void **)calloc(1, sizeof(void *));
	else
		succesori = (void **)realloc(succesori, (nr_succ+1)* sizeof(void *));
	succesori[nr_succ] = s;
	nr_succ ++;
}




