#include "Population.h"
#include "Generator.h"
#include "Evaluator.h"
#include "GeneticOperators.h"
#include "Selection.h"
#include <time.h>

#define DEBUG 0

/**
* the constructor
*
* @param i the number of chromosomes
* @param g the number of generations the population will evolve
* @param l the number of genes contained by a chromosome
* @param t the input graph of tasks
* @param p the input graph of processors
*/
Population::Population(int i, int g, int l, TaskGraf t, ProcesorGraf p )
{
	no_ind = i;
	no_gen = g;
	length = l;
	tasks = t;
	procs = p;
	run();
}

/**
* method that returns the best chromosome obtained
*
* @return the best chromosome of the current population
*/
Chromosome Population::getBest()
{
	return best;
}

/**
* method starting the population's evolution
*/
void Population::run(){}


